variables:
  RANCHER_URL: https://rancher.legauf.fr/v3
  RANCHER_CONTEXT: local:p-jvvm6
  APP_NAMESPACE: apps
  APP: $CI_PROJECT_NAME
  CHARTS_REPOSITORY: ${CI_API_V4_URL}/projects/31856448/packages/helm/stable

stages:
  - plan
  - deploy


.helm-job:
  image: fjeannot/k8s-tools:latest
  before_script:
    - helm repo add --username gitlab-ci-token --password $CI_JOB_TOKEN gitlab-repo $CHARTS_REPOSITORY
    - helm repo update
    - rancher login $RANCHER_URL --token $RANCHER_BEARER_TOKEN --context $RANCHER_CONTEXT
    - rancher namespace create $APP_NAMESPACE 2> /dev/null && echo "[INFO] Namespace '$APP_NAMESPACE' has been created." || true
    - rancher kubectl config view --raw > ~/.kube/config
    - sed -i "s~SECRETKEY~${SECRETKEY}~g" envs/common/values.yaml
    - sed -i "s~DB_HOST~${DB_HOST}~g" envs/common/values.yaml
    - sed -i "s~DB_USER~${DB_USER}~g" envs/common/values.yaml
    - sed -i "s~DB_PASSWORD~${DB_PASSWORD}~g" envs/common/values.yaml
    - sed -i "s~DB_DB~${DB_DB}~g" envs/common/values.yaml
  script:
    - >
      for file in envs/$CI_COMMIT_REF_SLUG/*; do
        cat $file >> .values.yaml
        echo >> .values.yaml
      done
    - render .values.yaml
    - render envs/common/values.yaml
    - . ./application
    - helm template $APP $chart_name -f envs/common/values.yaml -f .values.yaml --version $chart_version --namespace=$APP_NAMESPACE
    - helm upgrade --force $APP $chart_name --install -f envs/common/values.yaml -f .values.yaml --version $chart_version --namespace=$APP_NAMESPACE $HELM_OPTIONS

dev:plan:
  extends: .helm-job
  stage: plan
  environment:
    name: dev
  variables:
    HELM_OPTIONS: "--dry-run"
  only: ['dev']

dev:deploy:
  extends: .helm-job
  stage: deploy
  environment:
    name: dev
  only: ['dev']

int:plan:
  extends: .helm-job
  stage: plan
  environment:
    name: int
  variables:
    HELM_OPTIONS: "--dry-run"
  only: ['main']

int:deploy:
  extends: .helm-job
  stage: deploy
  environment:
    name: int
  only: ['main']
